Gecode::Int::Order::OrderProp Class Reference
Other available functionality » Integer propagators

Scheduling propagator for ordering two tasks More...

`#include <order.hh>`

## Public Member Functions

virtual Actor * | copy (Space &home)
| Copy propagator during cloning.
virtual PropCost | cost (const Space &home, const ModEventDelta &med) const
| Cost function (defined as low binary).
virtual void | reschedule (Space &home)
| Schedule function.
virtual ExecStatus | propagate (Space &home, const ModEventDelta &med)
| Perform propagation.
virtual size_t | dispose (Space &home)
| Delete propagator and return its size.
ModEventDelta | modeventdelta (void) const
| Return the modification event delta.
virtual ExecStatus | advise (Space &home, Advisor &a, const Delta &d)
| Advise function.
virtual void | advise (Space &home, Advisor &a)
| Run advisor a to be run on failure in failed space.
double | afc (void) const
| Return the accumlated failure count.
unsigned int | id (void) const
| Return propagator id.
PropagatorGroup | group (void) const
| Return group propagator belongs to.
void | group (PropagatorGroup g)
| Add propagator to group g.
bool | disabled (void) const
| Whether propagator is currently disabled.
virtual | ~Actor (void)
| To avoid warnings.

## Static Public Member Functions

static ExecStatus | post (Home home, IntView s0, int p0, IntView s1, int p1, BoolView b)
| Post order propagator.
static void * | operator new (size_t s, Space &home)
| Allocate memory from space.
static void | operator delete (void *p, Space &home)
| No-op for exceptions.
static void * | operator new (size_t s)
| Not used.
static void | operator delete (void *p)
| Not used.

## Protected Member Functions

| OrderProp (Space &home, OrderProp &p)
| Constructor for cloning.
| OrderProp (Home home, IntView s0, int p0, IntView s1, int p1, BoolView b)
| Constructor for creation.
Protected Member Functions inherited from Gecode::Propagator
| Propagator (Home home)
| Constructor for posting.
| Propagator (Space &home, Propagator &p)
| Constructor for cloning p.
Propagator * | fwd (void) const
| Return forwarding pointer during copying.
Kernel::GPI::Info & | gpi (void)
| Provide access to global propagator information.

## Protected Attributes

IntView | s0
| View for start times.
IntView | s1
BoolView | b
| Boolean view for order.
int | p0
| Processing times.
int | p1

## Detailed Description

Scheduling propagator for ordering two tasks

Requires

#include <gecode/int/order.hh>
order.hh

Definition at line 53 of file order.hh.

## Constructor & Destructor Documentation

## OrderProp() [1/2]

Gecode::Int::Order::OrderProp::OrderProp | ( | Space & | home,
|  | OrderProp & | p )

inline protected

Constructor for cloning.

Definition at line 67 of file propagate.hpp.

## OrderProp() [2/2]

Gecode::Int::Order::OrderProp::OrderProp | ( | Home | home,
|  | IntView | s0,
|  | int | p0,
|  | IntView | s1,
|  | int | p1,
|  | BoolView | b )

inline protected

Constructor for creation.

Definition at line 39 of file propagate.hpp.

## Member Function Documentation

## copy()

Actor * Gecode::Int::Order::OrderProp::copy | ( | Space & | home | ) |

virtual

Copy propagator during cloning.

Implements Gecode::Actor.

Definition at line 39 of file propagate.cpp.

## cost()

PropCost Gecode::Int::Order::OrderProp::cost | ( | const Space & | home,
|  | const ModEventDelta & | med ) const

virtual

Cost function (defined as low binary).

Implements Gecode::Propagator.

Definition at line 44 of file propagate.cpp.

## reschedule()

void Gecode::Int::Order::OrderProp::reschedule | ( | Space & | home | ) |

virtual

Schedule function.

Implements Gecode::Propagator.

Definition at line 49 of file propagate.cpp.

## propagate()

ExecStatus Gecode::Int::Order::OrderProp::propagate | ( | Space & | home,
|  | const ModEventDelta & | med )

virtual

Perform propagation.

Implements Gecode::Propagator.

Definition at line 56 of file propagate.cpp.

## post()

ExecStatus Gecode::Int::Order::OrderProp::post | ( | Home | home,
|  | IntView | s0,
|  | int | p0,
|  | IntView | s1,
|  | int | p1,
|  | BoolView | b )

inline static

Post order propagator.

Definition at line 48 of file propagate.hpp.

## dispose()

size_t Gecode::Int::Order::OrderProp::dispose | ( | Space & | home | ) |

virtual

Delete propagator and return its size.

Reimplemented from Gecode::Actor.

Definition at line 76 of file propagate.cpp.

## Member Data Documentation

## s0

IntView Gecode::Int::Order::OrderProp::s0

protected

View for start times.

Definition at line 56 of file order.hh.

## s1

IntView Gecode::Int::Order::OrderProp::s1

protected

Definition at line 56 of file order.hh.

## b

BoolView Gecode::Int::Order::OrderProp::b

protected

Boolean view for order.

Definition at line 58 of file order.hh.

## p0

int Gecode::Int::Order::OrderProp::p0

protected

Processing times.

Definition at line 60 of file order.hh.

## p1

int Gecode::Int::Order::OrderProp::p1

protected

Definition at line 60 of file order.hh.

The documentation for this class was generated from the following files:

- gecode/int/order.hh
- gecode/int/order/propagate.cpp
- gecode/int/order/propagate.hpp